/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package validatesitav1;

import java.io.File;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import org.sanskritlibrary.SAXParser;
import org.sanskritlibrary.SAXParserHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 *
 * @author ralph
 */
public class ProcessCatalog implements SAXParserHandler {

    String catalog;
    String textDirectory;
    String annotationsDirectory;
    SAXParser saxParser;
    Locator locator;
    Hashtable<String, Boolean> manuscriptDirectories = new Hashtable<String, Boolean>();
    StringBuilder currentBuffer = new StringBuilder();
    Hashtable<String, Boolean> missing = new Hashtable<String, Boolean>();
    Hashtable<String, Boolean> knownEmpty = new Hashtable<String, Boolean>();
    String currentDirectoryName;
    ArrayList<String> textTypes = new ArrayList<String>();

    public ProcessCatalog(String catalog, String textDirectory, String annotationsDirectory) {
        this.catalog = catalog;
        this.textDirectory = textDirectory;
        this.annotationsDirectory = annotationsDirectory;
        saxParser = new SAXParser(this);
        initKnownEmpties ();
    }

    private void initKnownEmpties () {
        knownEmpty.put(makeKey("MBh15Supp", "Brown/36"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh17Supp", "Brown/36"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item351"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh05Supp", "UPenn/mscoll390_item375"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh13Supp", "UPenn/mscoll390_item401"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12ShantiParvan", "UPenn/mscoll390_item488"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item488"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12ShantiParvan", "UPenn/mscoll390_item489"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item490"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh13Supp", "UPenn/mscoll390_item2186"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh06Supp", "UPenn/mscoll390_item2247"), Boolean.TRUE);
        knownEmpty.put(makeKey("HarivamsaSLText", "UPenn/mscoll390_item2248_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("HarivamsaSLStar", "UPenn/mscoll390_item2248_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh13Supp", "UPenn/mscoll390_item2326"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh13Supp", "UPenn/mscoll390_item2334"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh03Supp", "UPenn/mscoll390_item2372_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2388"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2408"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh13Supp", "UPenn/mscoll390_item2412"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2445"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2475"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2486"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2487"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2491"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2496_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2639_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12ShantiParvan", "UPenn/mscoll390_item2654_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2654_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12ShantiParvan", "UPenn/mscoll390_item2664_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2664_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12ShantiParvan", "UPenn/mscoll390_item2666_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh12Supp", "UPenn/mscoll390_item2666_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("MBh05Supp", "UPenn/mscoll390_item2780"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "Brown/44"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "Brown/45"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "Brown/46"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "Brown/47"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "Brown/49"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "Brown/50"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "Brown/52"), Boolean.TRUE);
        knownEmpty.put(makeKey("_unknown_text", "UPenn/mscoll390_item391_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item749_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("_unknown_text", "UPenn/mscoll390_item2180_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item2184_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("_unknown_text", "UPenn/mscoll390_item2279"), Boolean.TRUE);
        knownEmpty.put(makeKey("_unknown_text", "UPenn/mscoll390_item2310_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("_unknown_text", "UPenn/mscoll390_item2311"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item2514"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item2639_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item388"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item390"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item398"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item426"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item448"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item452_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item491"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2197_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2198_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2222"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item2231"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2239_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2242_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2327"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2341_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2343"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2348"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item2363"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item2402_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item2437_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("BhG", "UPenn/mscoll390_item2579_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item2814_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("_missing_text", "UPenn/mscoll390_item2815_wk1"), Boolean.TRUE);
        knownEmpty.put(makeKey("", ""), Boolean.TRUE);
        
    }
    
    private String makeKey(String type, String directoryName) {
        return String.format("%s%s/%s", annotationsDirectory, type, directoryName);
    }

    public void parse() throws Exception {
        saxParser.parse(catalog);
    }

    public Hashtable<String, Boolean> getManuscriptDirectories() {
        return manuscriptDirectories;
    }

    public void warning(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void error(SAXParseException exception) throws SAXException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void fatalError(SAXParseException exception) throws SAXException {
        System.out.format("%d.%d %s\n", locator.getLineNumber(), locator.getColumnNumber(), exception.getMessage());
    }

    public void setDocumentLocator(Locator locator) {
        this.locator = locator;
    }

    public void startDocument() throws SAXException {
    }

    public void endDocument() throws SAXException {
        Enumeration<String> en = missing.keys();
        while (en.hasMoreElements()) {
            String key = en.nextElement();
            System.out.format("touch %s.slp\n", key);
            System.out.format("touch %s.deva\n", key);
            System.out.format("touch %s.roman\n", key);
        }
    }

    public void startPrefixMapping(String prefix, String uri) throws SAXException {
    }

    public void endPrefixMapping(String prefix) throws SAXException {
    }

    public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
    }

    public void endElement(String uri, String localName, String qName) throws SAXException {
        String buffer = currentBuffer.toString().trim();
        if (qName.equals("directoryName")) {
            currentDirectoryName = buffer;
            if (manuscriptDirectories.get(buffer) != null) {
                System.out.format("Duplicate directoryName: %s\n", buffer);
            } else {
                manuscriptDirectories.put(buffer, true);
            }
        } else if (qName.equals("textType")) {
            if (missing.get(buffer) == null) {
                boolean isMissing = false;
                textTypes.add(buffer);
                String fn = textDirectory + buffer + ".slp";
                if (!new File(fn).exists()) {
                    System.out.format("File %s does not exist\n", fn);
                    isMissing = true;
                }

                fn = textDirectory + buffer + ".deva";
                if (!new File(fn).exists()) {
                    System.out.format("File %s does not exist\n", fn);
                    isMissing = true;
                }

                fn = textDirectory + buffer + ".roman";
                if (!new File(fn).exists()) {
                    System.out.format("File %s does not exist\n", fn);
                    isMissing = true;
                }
                if (isMissing) {
                    missing.put(buffer, true);
                    System.out.println();
                }
            }
        } else if (qName.equals("manuscript")) {
            for (String type : textTypes) {

                String fn = String.format("%s%s/%s", annotationsDirectory, type, currentDirectoryName);
                if (new File(fn).exists() == false) {
                    String key = String.format("%s%s/%s", annotationsDirectory, type, currentDirectoryName);
                    if (knownEmpty.get(key) == null) {
                        System.out.format("annotations/%s/%s is empty\n", type, currentDirectoryName);
                    }
                }
            }
            textTypes.clear();
        }
        currentBuffer.setLength(0);
    }

    public void characters(char[] ch, int start, int length) throws SAXException {
        currentBuffer.append(new String(ch, start, length));
    }
}
